- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- File List
- File Members

# /home/coin/SVN-release/Osi-0.98.1/CoinUtils/src/CoinPresolveMatrix.hpp File Reference

`#include "CoinPragma.hpp"`
`#include "CoinPackedMatrix.hpp"`
`#include "CoinMessage.hpp"`
`#include "CoinTime.hpp"`
`#include <cmath>`
`#include <cassert>`
`#include <cfloat>`

Include dependency graph for CoinPresolveMatrix.hpp:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes
class | CoinPresolveAction
| Abstract base class of all presolve routines. More...
class | CoinPrePostsolveMatrix
| Collects all the information about the problem that is needed in both presolve and postsolve. More...
class | presolvehlink
| Links to aid in packed matrix modification. More...
class | CoinPresolveMatrix
| Augments CoinPrePostsolveMatrix with information about the problem that is only needed during presolve. More...
class | CoinPostsolveMatrix
| Augments CoinPrePostsolveMatrix with information about the problem that is only needed during postsolve. More...
## Defines
#define | deleteAction(array, type) delete [] array
#define | PRESOLVEASSERT(x)
#define | PRESOLVE_STMT(s)
#define | PRESOLVE_INF COIN_DBL_MAX
#define | NO_LINK -66666666
#define | PRESOLVEFINITE(n) (-PRESOLVE_INF < (n) && (n) < PRESOLVE_INF)
## Functions
void | DIE (const char *s)
int | ALIGN (int n, int m)
int | ALIGN_DOUBLE (int n)
void | presolve_delete_many_from_major (int majndx, char *marked, const CoinBigIndex *majstrts, int *majlens, int *minndxs, double *els)
double * | presolve_dupmajor (const double *elems, const int *indices, int length, CoinBigIndex offset, int tgt=-1)
| Duplicate a major-dimension vector; optionally omit the entry with minor index `tgt`.
## Variables
const double | ZTOLDP = 1e-12
| Zero tolerance.

## Detailed Description

Declarations for CoinPresolveMatrix and CoinPostsolveMatrix and their common base class CoinPrePostsolveMatrix. Also declarations for CoinPresolveAction and a number of non-member utility functions.

Definition in file CoinPresolveMatrix.hpp.

## Define Documentation

#define deleteAction | ( | array,
|  | type |  | ) | delete [] array

Definition at line 29 of file CoinPresolveMatrix.hpp.

Referenced by drop_empty_cols_action::~drop_empty_cols_action(), drop_empty_rows_action::~drop_empty_rows_action(), drop_zero_coefficients_action::~drop_zero_coefficients_action(), make_fixed_action::~make_fixed_action(), slack_doubleton_action::~slack_doubleton_action(), and slack_singleton_action::~slack_singleton_action().

#define PRESOLVEASSERT | ( | x |  | ) |

Definition at line 55 of file CoinPresolveMatrix.hpp.

#define PRESOLVE_STMT | ( | s |  | ) |

Definition at line 56 of file CoinPresolveMatrix.hpp.

Referenced by CoinPresolveMatrix::change_bias().

#define PRESOLVE_INF COIN_DBL_MAX

Definition at line 69 of file CoinPresolveMatrix.hpp.

Referenced by CoinPrePostsolveMatrix::setColumnStatus().

#define NO_LINK -66666666

Definition at line 683 of file CoinPresolveMatrix.hpp.

Referenced by presolvehlink::PRESOLVE_MOVE_LINK(), and presolvehlink::PRESOLVE_REMOVE_LINK().

#define PRESOLVEFINITE | ( | n |  | ) | (-PRESOLVE_INF < (n) && (n) < PRESOLVE_INF)

Definition at line 1377 of file CoinPresolveMatrix.hpp.

## Function Documentation

void DIE | ( | const char * | s | ) | `[inline]`

Definition at line 58 of file CoinPresolveMatrix.hpp.

int ALIGN | ( | int | n,
|  | int | m |
| ) |  |  | `[inline]`

Definition at line 62 of file CoinPresolveMatrix.hpp.

Referenced by ALIGN_DOUBLE().

int ALIGN_DOUBLE | ( | int | n | ) | `[inline]`

Definition at line 63 of file CoinPresolveMatrix.hpp.

References ALIGN().

## Variable Documentation

const double ZTOLDP = 1e-12

Zero tolerance.

OSL had a fixed zero tolerance; we still use that here.

Definition at line 36 of file CoinPresolveMatrix.hpp.